#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"


#define OFDM_PKTDETECTOR_MIMO_OFFSET (0x00000000)
//Gateways In

#define ofdm_pktDetector_mimo_pktDet_detectionMask_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x0)
//tag name: in_0
//arith_type = Unsigned
//num_bits = 4
//bin_pt = 0
#define ofdm_pktDetector_mimo_pktDet_detectionMode_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x4)
//tag name: in_1
//arith_type = Unsigned
//num_bits = 1
//bin_pt = 0
#define ofdm_pktDetector_mimo_pktDet_reset_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x8)
//tag name: in_2
//arith_type = Unsigned
//num_bits = 1
//bin_pt = 0
#define ofdm_pktDetector_mimo_pktDet_masterReset_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0xC)
//tag name: in_3
//arith_type = Unsigned
//num_bits = 1
//bin_pt = 0
#define ofdm_pktDetector_mimo_pktDet_resetDuration_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x10)
//tag name: in_4
//arith_type = Unsigned
//num_bits = 16
//bin_pt = 0
#define ofdm_pktDetector_mimo_pktDet_avgLen_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x14)
//tag name: in_5
//arith_type = Unsigned
//num_bits = 5
//bin_pt = 0
#define ofdm_pktDetector_mimo_csma_enableBusy_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x18)
//tag name: in_6
//arith_type = Unsigned
//num_bits = 1
//bin_pt = 0
#define ofdm_pktDetector_mimo_pktDet_avgThresh_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x1C)
//tag name: in_7
//arith_type = Unsigned
//num_bits = 16
//bin_pt = 0
#define ofdm_pktDetector_mimo_csma_avgThresh_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x20)
//tag name: in_8
//arith_type = Unsigned
//num_bits = 16
//bin_pt = 0
#define ofdm_pktDetector_mimo_csma_enableIdle_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x24)
//tag name: in_9
//arith_type = Unsigned
//num_bits = 1
//bin_pt = 0
#define ofdm_pktDetector_mimo_csma_difsPeriod_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x28)
//tag name: in_10
//arith_type = Unsigned
//num_bits = 10
//bin_pt = 0

//Gateways Out

#define ofdm_pktDetector_mimo_pktDet_idleDifs_OFFSET (OFDM_PKTDETECTOR_MIMO_OFFSET+0x2C)
//tag name: out_11


#define ofdm_pktDetector_mimo_WriteReg(BaseAddress, RegOffset, Data) \
	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

#define ofdm_pktDetector_mimo_ReadReg(BaseAddress, RegOffset) \
	XIo_In32((BaseAddress) + (RegOffset))

//Write Reg Macro

#define ofdm_pktDetector_mimo_WriteReg_pktDet_detectionMask(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_detectionMask_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_pktDet_detectionMode(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_detectionMode_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_pktDet_reset(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_reset_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_pktDet_masterReset(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_masterReset_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_pktDet_resetDuration(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_resetDuration_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_pktDet_avgLen(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_avgLen_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_csma_enableBusy(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_csma_enableBusy_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_pktDet_avgThresh(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_avgThresh_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_csma_avgThresh(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_csma_avgThresh_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_csma_enableIdle(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_csma_enableIdle_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_csma_difsPeriod(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_csma_difsPeriod_OFFSET), (Xuint32)(Value))
#define ofdm_pktDetector_mimo_WriteReg_pktDet_idleDifs(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_idleDifs_OFFSET), (Xuint32)(Value))


//Read Reg Macro

#define ofdm_pktDetector_mimo_ReadReg_pktDet_detectionMask(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_detectionMask_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_pktDet_detectionMode(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_detectionMode_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_pktDet_reset(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_reset_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_pktDet_masterReset(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_masterReset_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_pktDet_resetDuration(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_resetDuration_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_pktDet_avgLen(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_avgLen_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_csma_enableBusy(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_csma_enableBusy_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_pktDet_avgThresh(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_avgThresh_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_csma_avgThresh(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_csma_avgThresh_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_csma_enableIdle(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_csma_enableIdle_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_csma_difsPeriod(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_csma_difsPeriod_OFFSET))
#define ofdm_pktDetector_mimo_ReadReg_pktDet_idleDifs(BaseAddress) \
	XIo_In32((BaseAddress) + (ofdm_pktDetector_mimo_pktDet_idleDifs_OFFSET))
